MODULE_NAME='RGB_Spectrum_4View_UI' (DEV vdvDEV, DEV dvTP)
(*{{PS_SOURCE_INFO(PROGRAM STATS)                          *)
(***********************************************************)
(*  FILE CREATED ON: 01/30/2003 AT: 08:51:36               *)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 07/18/2003 AT: 07:21:39         *)
(***********************************************************)
(*  ORPHAN_FILE_PLATFORM: 1                                *)
(***********************************************************)
(*!!FILE REVISION: Rev 0                                   *)
(*  REVISION DATE: 07/11/2003                              *)
(*                                                         *)
(*  COMMENTS:                                              *)
(*                                                         *)
(***********************************************************)
(*}}PS_SOURCE_INFO                                         *)
(***********************************************************)

(***********************************************************)
(* System Type : Netlinx                                   *)
(***********************************************************)
(* REV HISTORY:                                            *)
(***********************************************************)

(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE
(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT
(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE
(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

VOLATILE CHAR sVERSION[5]           // STORES NETLINX COMM MODULE VERSION NUMBER
VOLATILE INTEGER nDEBUG = 0         // TRACKS THE ON/OFF STATE OF DEBUG MSGS SENT TO THE TELNET SESSION
VOLATILE INTEGER nCUR_INPUT = 0     // TRACKS THE CURRENTLY SELECTED INPUT
VOLATILE INTEGER nCUR_TYPE = 0      // TRACKS THE TYPE OF THE CURRENTLY SELECTED INPUT
VOLATILE INTEGER nENABLE_LEVEL = 1  // INDICATES WHEN ITS OK TO ACTIVATE THE TP LEVELS
VOLATILE INTEGER nDEVICE_SCALE = 0  // STORES THE ON/OFF STATE OF DEVICE SCALE
VOLATILE INTEGER nBANK = 0          // STORES THE CURRENT COMPOSITE BANK, 1=BANK A, 2=BANK B
VOLATILE INTEGER nDIMMER = 0        // STORES THE CURRENT FRONT PANEL BRIGHTNESS LEVEL, 0 = OFF, 1 = ON
VOLATILE INTEGER nFRAMELOCK = 0     // STORES THE CURRENT FRAME LOCK STATE, 0 = OFF, 1 = ON
VOLATILE INTEGER nFREEZE = 0        // STORES THE CURRENT INPUT'S FREEZE STATE
VOLATILE INTEGER nFULLSCREEN = 0    // STORES THE CURRENT FULL SCREEN STATE
VOLATILE INTEGER nLOCK = 0          // STORES THE FRONT PANEL LOCKOUT STATE
VOLATILE INTEGER nSTANDARD = 0      // STORES THE CURRENT OPERATING STANDARD
VOLATILE INTEGER nOVERSCAN = 0      // STORES THE CURRENT INPUT'S OVER_SCAN STATE
VOLATILE SLONG slBRIGHTNESS = 0     // STORES THE CURRENT INPUT'S BRIGHTNE SS LEVEL
VOLATILE SLONG slCONTRAST = 0       // STORES THE CURRENT INPUT'S CONTRAST LEVEL
VOLATILE SLONG slSHARPNESS = 0      // STORES THE CURRENT INPUT'S SHARPNESS LEVEL
VOLATILE SLONG slHUE = 0            // STORES THE CURRENT INPUT'S HUE LEVEL
VOLATILE SLONG slSATURATION = 0     // STORES THE CURRENT INPUT'S SATURATION LEVEL
(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING
(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE
(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)
DEFINE_FUNCTION SLONG Scale_Range(SLONG slNum_In, SLONG slMin_In, SLONG slMax_In, SLONG slMin_Out, SLONG slMax_Out)
{
    SLONG slRange_In
    SLONG slRange_Out
    SLONG slNum_Out

    IF (slNum_In < slMin_In OR slNum_In > slMax_In)
    {
        SEND_STRING 0, "'ERROR=Invalid value. Enter a value between ',ITOA(slMin_In),' and ',ITOA(slMax_In),'.'"
        Return -999
    }
    ELSE
    {
        slRange_In = slMax_In - slMin_In      // Establish input range
        slRange_Out = slMax_Out - slMin_Out   // Establish output range
        slNum_In = slNum_In - slMin_In        // Remove input offset
        slNum_Out = slNum_In * slRange_Out    // Multiply by max out range
        slNum_Out = slNum_Out / slRange_In    // Then divide by max in range
        slNum_Out = slNum_Out + slMin_Out     // Add in minimum output value
        Return slNum_Out
    }
}
DEFINE_FUNCTION FLOAT fScale_Range(FLOAT fNum_In, FLOAT fMin_In, FLOAT fMax_In, FLOAT fMin_Out, FLOAT fMax_Out)
{
    FLOAT fRange_In
    FLOAT fRange_Out
    FLOAT fNum_Out

    IF (fNum_In < fMin_In OR fNum_In > fMax_In)
    {
        SEND_STRING 0, "'ERROR=Invalid value. Enter a value between ',FTOA(fMin_In),' and ',FTOA(fMax_In),'.'"
        Return -999
    }
    ELSE
    {
        fRange_In = fMax_In - fMin_In      // Establish input range
        fRange_Out = fMax_Out - fMin_Out   // Establish output range
        fNum_In = fNum_In - fMin_In        // Remove input offset
        fNum_Out = fNum_In * fRange_Out    // Multiply by max out range
        fNum_Out = fNum_Out / fRange_In    // Then divide by max in range
        fNum_Out = fNum_Out + fMin_Out     // Add in minimum output value
        Return fNum_Out
    }
}
(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START

SEND_COMMAND vdvDEV, "'BANK=A'"
(***********************************************************)
(*                THE EVENTS GOES BELOW                    *)
(***********************************************************)
DEFINE_EVENT

DATA_EVENT[vdvDEV]
{
    STRING:
    {
        STACK_VAR CHAR cCMD[35]
        
        IF(nDEBUG) { SEND_STRING 0, "'UI RECEIVED FROM COMM: ',DATA.TEXT" }
        IF(FIND_STRING(DATA.TEXT, '=', 1)) { cCMD = REMOVE_STRING(DATA.TEXT, '=', 1) }        
        ELSE { cCMD = DATA.TEXT }
        SWITCH(cCMD)
        {
            CASE 'BANK=':
            {
                IF (DATA.TEXT == 'A') { nBANK = 1 }
                ELSE IF (DATA.TEXT == 'B') { nBANK = 2 }
            }
            CASE 'BORDER=':
            {
                IF(DATA.TEXT == '1') {}
                ELSE IF (DATA.TEXT == '0') {}
            }
            CASE 'BORDER_COLOR=':
            {
                SWITCH(DATA.TEXT)
                {
                    CASE 'WHITE': {}
                    CASE 'YELLOW': {}
                    CASE 'CYAN': {}
                    CASE 'GREEN': {}
                    CASE 'MAGENTA': {}
                    CASE 'RED': {}
                    CASE 'BLUE': {}
                    CASE 'BLACK': {}
                    CASE 'TRANSPARENT': {}
                    CASE 'GRAY': {}
                    CASE 'DARK YELLOW': {}
                    CASE 'DARK CYAN': {}
                    CASE 'DARK GREEN': {}
                    CASE 'DARK MAGENTA': {}
                    CASE 'DARK RED': {}
                    CASE 'DARK BLUE': {}
                }
            }
            CASE 'BORDER_SIZE=':
            {
                STACK_VAR INTEGER nVERT, nHORIZ
                
                nVERT = ATOI(DATA.TEXt)
                REMOVE_STRING(DATA.TEXT, ':', 1)
                nHORIZ = ATOI(DATA.TEXt)
            }
            CASE 'BRIGHTNESS=':
            {
                STACK_VAR INTEGER nINPUT
                
                slBRIGHTNESS = ATOI(DATA.TEXT)
                REMOVE_STRING(DATA.TEXT, ':', 1)
                nINPUT = ATOI(DATA.TEXT)
                IF (nINPUT == nCUR_INPUT)
                {
                    IF (!nDEVICE_SCALE) { SEND_COMMAND dvTP, "'@TXT',6,ITOA(slBRIGHTNESS),'%'" }
                    ELSE { SEND_COMMAND dvTP, "'@TXT',6,ITOA(slBRIGHTNESS)" }
                }
                IF ([dvTP, 6] AND nINPUT == nCUR_INPUT)
                {
                    IF (!nDEVICE_SCALE)
                    {
                        SEND_COMMAND dvTP, "'@TXT',10,ITOA(slBRIGHTNESS),'%'"
                        SEND_LEVEL dvTP,1,slBRIGHTNESS*255/100
                    }
                    ELSE
                    {
                        STACK_VAR SLONG slVALUE
                        
                        SEND_COMMAND dvTP, "'@TXT',10,ITOA(slBRIGHTNESS)"
                        slVALUE = slBRIGHTNESS
                        slVALUE = Scale_Range(slVALUE, -500, 500, 0, 100)
                        IF (slVALUE <> -999) { SEND_LEVEL dvTP,1,slVALUE*255/100 }
                    }
                    nENABLE_LEVEL=0
                    CANCEL_WAIT 'ENABLE LEVELS'
                    WAIT 3 'ENABLE LEVELS' { nENABLE_LEVEL = 1 } // REMOVES UNDESIRABLE ECHO FEEDBACK
                }
            }
            CASE 'CONTRAST=':
            {
                STACK_VAR INTEGER nINPUT
                STACK_VAR SLONG slVALUE
                
                slCONTRAST = ATOI(DATA.TEXT)
                REMOVE_STRING(DATA.TEXT, ':', 1)
                nINPUT = ATOI(DATA.TEXT)
                IF (nINPUT == nCUR_INPUT)
                {
                    IF (!nDEVICE_SCALE) { SEND_COMMAND dvTP, "'@TXT',5,ITOA(slCONTRAST),'%'" }
                    ELSE { SEND_COMMAND dvTP, "'@TXT',5,ITOA(slCONTRAST)" }
                }
                IF ([dvTP, 5] AND nCUR_INPUT )
                {
                    IF (!nDEVICE_SCALE)
                    {
                        SEND_COMMAND dvTP, "'@TXT',10,ITOA(slCONTRAST),'%'"
                        SEND_LEVEL dvTP,1,slCONTRAST*255/100
                    }
                    ELSE
                    {
                        SEND_COMMAND dvTP, "'@TXT',10,ITOA(slCONTRAST)"
                        slVALUE = slCONTRAST
                        slVALUE = Scale_Range(slVALUE, 0, 199, 0, 100)
                        IF (slVALUE <> -999) { SEND_LEVEL dvTP,1,slVALUE*255/100 }
                    }
                    nENABLE_LEVEL=0
                    CANCEL_WAIT 'ENABLE LEVELS'
                    WAIT 3 'ENABLE LEVELS' { nENABLE_LEVEL = 1 } // REMOVES UNDESIRABLE ECHO FEEDBACK
                }
            }
            CASE 'DEBUG=': { nDEBUG = ATOI(DATA.TEXT) }
            CASE 'DEVICE_SCALE=':
            {
                IF (nDEVICE_SCALE <> ATOI(DATA.TEXT))
                {
                    nDEVICE_SCALE = ATOI(DATA.TEXT)
                    IF (nCUR_INPUT > 0)
                    {
                        SEND_COMMAND vdvDEV, "'HUE?',ITOA(nCUR_INPUT)"
                        SEND_COMMAND vdvDEV, "'SATURATION?',ITOA(nCUR_INPUT)"
                        SEND_COMMAND vdvDEV, "'SHARPNESS?',ITOA(nCUR_INPUT)"
                        SEND_COMMAND vdvDEV, "'CONTRAST?',ITOA(nCUR_INPUT)"
                        SEND_COMMAND vdvDEV, "'BRIGHTNESS?',ITOA(nCUR_INPUT)"
                    }
                }
            }
            CASE 'DIMMER=':
            {
                IF (DATA.TEXT == '1') { ON[nDIMMER] }
                ELSE IF (DATA.TEXT == '0') { OFF[nDIMMER] }
            }
            CASE 'ERRORM=': { SEND_STRING 0, "'ERROR - ',DATA.TEXT" }
            CASE 'FIRMWARE=': { SEND_COMMAND dvTP, "'@TXT',11,DATA.TEXT" }
            CASE 'FRAME_LOCK=':
            {
                IF (DATA.TEXT == '0') { OFF[nFRAMELOCK] }
                ELSE IF (DATA.TEXT == '1') { ON[nFRAMELOCK] }
            }
            CASE 'FREEZE=':
            {
                STACK_VAR INTEGER nSTATE, nINPUT
                
                nSTATE = ATOI(DATA.TEXT)
                REMOVE_STRING(DATA.TEXT, ':', 1)
                nINPUT = ATOI(DATA.TEXT)
                IF (nINPUT == nCUR_INPUT AND nSTATE == 1) { ON[nFREEZE] }
                ELSE IF (nINPUT == nCUR_INPUT AND nSTATE == 0) { OFF[nFREEZE] }
            }
            CASE 'FULL_SCREEN=':
            {
                STACK_VAR INTEGER N
                
                FOR(N = 15; N < 20; N++) { OFF[dvTP, N] }
                nFULLSCREEN = ATOI(DATA.TEXT)
            }
            CASE 'HUE=':
            {
                STACK_VAR INTEGER nINPUT
                
                slHUE = ATOI(DATA.TEXT)
                REMOVE_STRING(DATA.TEXT, ':', 1)
                nINPUT = ATOI(DATA.TEXT)
                IF (nCUR_INPUT == nINPUT)
                {
                    IF (!nDEVICE_SCALE) { SEND_COMMAND dvTP, "'@TXT',1,ITOA(slHUE),'%'" }
                    ELSE { SEND_COMMAND dvTP, "'@TXT',1,ITOA(slHUE)" }
                }
                IF ([dvTP, 1] AND nCUR_INPUT == nINPUT)
                {
                    IF (!nDEVICE_SCALE)
                    {
                        SEND_COMMAND dvTP, "'@TXT',10,ITOA(slHUE),'%'"
                        SEND_LEVEL dvTP,1,slHUE*255/100
                    }
                    ELSE
                    {
                        STACK_VAR SLONG slVALUE

                        SEND_COMMAND dvTP, "'@TXT',10,ITOA(slHUE)"
                        slVALUE = slHUE
                        slVALUE = Scale_Range(slVALUE, -180, 180, 0, 100)
                        IF (slVALUE <> -999) { SEND_LEVEL dvTP,1,slVALUE*255/100 }
                    }
                    nENABLE_LEVEL=0
                    CANCEL_WAIT 'ENABLE LEVELS'
                    WAIT 3 'ENABLE LEVELS' { nENABLE_LEVEL = 1 } // REMOVES UNDESIRABLE ECHO FEEDBACK
                }
            }
            CASE 'INPUT_NAME=':
            {
                STACK_VAR INTEGER nINPUT
                STACK_VAR CHAR sNAME[20]
                
                nINPUT = ATOI(DATA.TEXT)
                REMOVE_STRING(DATA.TEXT, ':', 1)
                sNAME = DATA.TEXT
            }
            CASE 'INPUT_TYPE=':
            {
                STACK_VAR INTEGER nINPUT
                
                nINPUT = ATOI(DATA.TEXT)
                REMOVE_STRING(DATA.TEXT, ':', 1)
                SWITCH(DATA.TEXT)
                {
                    CASE 'COMPOSITE-A': { nCUR_TYPE = 1 }
                    CASE 'COMPOSITE-B': { nCUR_TYPE = 2 }
                    CASE 'S-VIDEO'    : { nCUR_TYPE = 3 }
                }
            }
            CASE 'LCD_CONTRAST=':
            {
                
            }
            CASE 'LOCK=':
            {
                IF (DATA.TEXT == '0') { OFF[nLOCK] }
                ELSE IF (DATA.TEXT == '1') { ON[nLOCK] }
            }
            CASE 'MODEL=': { SEND_COMMAND dvTP, "'@TXT', 2, DATA.TEXT" }
            CASE 'NAME=':
            {
                IF (DATA.TEXT == '0') {}
                ELSE IF (DATA.TEXT == '1') {}
            }
            CASE 'NAME_COLOR=':
            {
                SWITCH(DATA.TEXT)
                {
                    CASE 'WHITE': {}
                    CASE 'YELLOW': {}
                    CASE 'CYAN': {}
                    CASE 'GREEN': {}
                    CASE 'MAGENTA': {}
                    CASE 'RED': {}
                    CASE 'BLUE': {}
                    CASE 'BLACK': {}
                    CASE 'TRANSPARENT': {}
                    CASE 'GRAY': {}
                    CASE 'DARK YELLOW': {}
                    CASE 'DARK CYAN': {}
                    CASE 'DARK GREEN': {}
                    CASE 'DARK MAGENTA': {}
                    CASE 'DARK RED': {}
                    CASE 'DARK BLUE': {}
                }
            }
            CASE 'NAME_POSITION=':
            {
                IF (DATA.TEXT == 'T') {}
                ELSE IF (DATA.TEXT == 'B') {}
            }
            CASE 'OPERATING_STANDARD=':
            {
                STACK_VAR CHAR cMODE, cFORMAT, cSCAN
                STACK_VAR INTEGER N
                
                cMODE = GET_BUFFER_CHAR(DATA.TEXT)
                GET_BUFFER_CHAR(DATA.TEXT)          // REMOVE ':'
                cFORMAT = GET_BUFFER_CHAR(DATA.TEXT)
                GET_BUFFER_CHAR(DATA.TEXT)          // REMOVE ':'
                cSCAN = GET_BUFFER_CHAR(DATA.TEXT)
                FOR(N = 34; N < 38; N++) { OFF[dvTP, N] }
                SELECT
                {
                    ACTIVE(cMODE == 'N' AND cFORMAT == 'N' AND cSCAN == 'P'): { nSTANDARD = 1 }
                    ACTIVE(cMODE == 'N' AND cFORMAT == 'N' AND cSCAN == 'I'): { nSTANDARD = 2 }
                    ACTIVE(cMODE == 'N' AND cFORMAT == 'W' AND cSCAN == 'P'): { nSTANDARD = 3 }
                    ACTIVE(cMODE == 'P' AND cFORMAT == 'N' AND cSCAN == 'I'): { nSTANDARD = 4 }
                }
            }
            CASE 'OVER_SCAN=':
            {
                STACK_VAR INTEGER nINPUT
                
                nINPUT = ATOI(DATA.TEXT)
                REMOVE_STRING(DATA.TEXT, ':', 1)
                IF (DATA.TEXT == 'OFF') { OFF[nOVERSCAN] }
                ELSE IF (DATA.TEXT == 'ON') { ON[nOVERSCAN] }
            }
            CASE 'SATURATION=':
            {
                STACK_VAR INTEGER nINPUT
                STACK_VAR SLONG slVALUE
                
                slVALUE = ATOI(DATA.TEXT)
                REMOVE_STRING(DATA.TEXT, ':', 1)
                nINPUT = ATOI(DATA.TEXT)
                IF (nINPUT == nCUR_INPUT)
                {
                    IF (!nDEVICE_SCALE) { SEND_COMMAND dvTP, "'@TXT',9,ITOA(slVALUE),'%'" }
                    ELSE { SEND_COMMAND dvTP, "'@TXT',9,ITOA(slVALUE)" }
                    slSATURATION = slVALUE
                }
                IF ([dvTP, 9] AND nCUR_INPUT )
                {
                    IF (!nDEVICE_SCALE)
                    {
                        SEND_COMMAND dvTP, "'@TXT',10,ITOA(slVALUE),'%'"
                        SEND_LEVEL dvTP,1,slVALUE*255/100
                    }
                    ELSE
                    {
                        SEND_COMMAND dvTP, "'@TXT',10,ITOA(slVALUE)"
                        slVALUE = Scale_Range(slVALUE, 0, 199, 0, 100)
                        IF (slVALUE <> -999) { SEND_LEVEL dvTP,1,slVALUE*255/100 }
                    }
                    nENABLE_LEVEL=0
                    CANCEL_WAIT 'ENABLE LEVELS'
                    WAIT 3 'ENABLE LEVELS' { nENABLE_LEVEL = 1 } // REMOVES UNDESIRABLE ECHO FEEDBACK
                }
            }
            CASE 'SHARPNESS=':
            {
                STACK_VAR INTEGER nINPUT
                STACK_VAR SLONG slVALUE
                
                slVALUE = ATOI(DATA.TEXT)
                REMOVE_STRING(DATA.TEXT, ':', 1)
                nINPUT = ATOI(DATA.TEXT)
                IF (nINPUT == nCUR_INPUT)
                {
                    IF (!nDEVICE_SCALE) { SEND_COMMAND dvTP, "'@TXT',4,ITOA(slVALUE),'%'" }
                    ELSE { SEND_COMMAND dvTP, "'@TXT',4,ITOA(slVALUE)" }
                    slSHARPNESS = slVALUE
                }
                IF ([dvTP, 4] AND nINPUT == nCUR_INPUT)
                {
                    IF (!nDEVICE_SCALE)
                    {
                        SEND_COMMAND dvTP, "'@TXT',10,ITOA(slVALUE),'%'"
                        SEND_LEVEL dvTP,1,slVALUE*255/100
                    }
                    ELSE
                    {
                        SEND_COMMAND dvTP, "'@TXT',10,ITOA(slVALUE)"
                        slVALUE = Scale_Range(slVALUE, -8, 7, 0, 100)
                        IF (slVALUE <> -999) { SEND_LEVEL dvTP,1,slVALUE*255/100 }
                    }
                    nENABLE_LEVEL=0
                    CANCEL_WAIT 'ENABLE LEVELS'
                    WAIT 3 'ENABLE LEVELS' { nENABLE_LEVEL = 1 } // REMOVES UNDESIRABLE ECHO FEEDBACK
                }
            }
            CASE 'VERSION=': { sVERSION = DATA.TEXT }
        }// END SWITCH(cCMD)
    }// END STRING
}// END DATA_EVENT[vdvDEV]

DATA_EVENT[dvTP]
{
    ONLINE: 
    {
        STACK_VAR INTEGER I
        
        FOR(I = 1; I <= 255; I++) { SEND_COMMAND dvTP, "'@TXT',I,''" }
        SEND_COMMAND dvTP, "'@PPX'"
    }
}// END DATA_EVENT[dvTP]

LEVEL_EVENT[dvTP, 1]
{
    IF (nENABLE_LEVEL)
    {
        CANCEL_WAIT 'SEND NEW LEVEL'
        WAIT 2 'SEND NEW LEVEL'
        {
            SELECT
            {
                ACTIVE([dvTP, 1]):
                {
                    IF(!nDEVICE_SCALE){SEND_COMMAND vdvDEV,"'HUE=',ITOA(LEVEL.VALUE*100/255),':',ITOA(nCUR_INPUT)"}
                    ELSE
                    {
                        LOCAL_VAR SLONG slVAL
                        
                        slVAL = Scale_Range(LEVEL.VALUE*100/255, 0, 100, -180, 180)
                        IF (slVAL <> -999) { SEND_COMMAND vdvDEV,"'HUE=',ITOA(slVAL),':',ITOA(nCUR_INPUT)" }
                        
                    }
                }
                ACTIVE([dvTP, 4]):
                {
                    IF(!nDEVICE_SCALE){SEND_COMMAND vdvDEV,"'SHARPNESS=',ITOA(LEVEL.VALUE*100/255),':',ITOA(nCUR_INPUT)"}
                    ELSE
                    {
                        LOCAL_VAR SLONG slVAL
                        
                        slVAL = Scale_Range(LEVEL.VALUE*100/255, 0, 100, -8, 7)
                        IF (slVAL <> -999) { SEND_COMMAND vdvDEV,"'SHARPNESS=',ITOA(slVAL),':',ITOA(nCUR_INPUT)" }
                    }
                }
                ACTIVE([dvTP, 5]):
                {
                    IF(!nDEVICE_SCALE){SEND_COMMAND vdvDEV,"'CONTRAST=',ITOA(LEVEL.VALUE*100/255),':',ITOA(nCUR_INPUT)" }
                    ELSE
                    {
                        LOCAL_VAR SLONG slVAL
                        
                        slVAL = Scale_Range(LEVEL.VALUE*100/255, 0, 100, 0, 199)
                        IF (slVAL <> -999) { SEND_COMMAND vdvDEV, "'CONTRAST=',ITOA(slVAL),':',ITOA(nCUR_INPUT)" }
                    }
                }
                ACTIVE([dvTP, 6]):
                {
                    IF(!nDEVICE_SCALE){SEND_COMMAND vdvDEV,"'BRIGHTNESS=',ITOA(LEVEL.VALUE*100/255),':',ITOA(nCUR_INPUT)"}
                    ELSE
                    {
                        LOCAL_VAR SLONG slVAL
                        
                        slVAL = Scale_Range(LEVEL.VALUE*100/255, 0, 100, -500, 500)
                        IF (slVAL <> -999) { SEND_COMMAND vdvDEV,"'BRIGHTNESS=',ITOA(slVAL),':',ITOA(nCUR_INPUT)" }
                        
                    }
                }
                ACTIVE([dvTP, 9]):
                {
                    IF(!nDEVICE_SCALE){SEND_COMMAND vdvDEV,"'SATURATION=',ITOA(LEVEL.VALUE*100/255),':',ITOA(nCUR_INPUT)"}
                    ELSE
                    {
                        LOCAL_VAR SLONG slVAL
                        
                        slVAL = Scale_Range(LEVEL.VALUE*100/255, 0, 100, 0, 199)
                        IF (slVAL <> -999) { SEND_COMMAND vdvDEV,"'SATURATION=',ITOA(slVAL),':',ITOA(nCUR_INPUT)" }
                        
                    }
                }
            }
        }
    }
}

BUTTON_EVENT[dvTP, 1]           // HUE BUTTON
BUTTON_EVENT[dvTP, 4]           // SHARPNESS BUTTON
BUTTON_EVENT[dvTP, 5]           // CONTRAST BUTTON
BUTTON_EVENT[dvTP, 6]           // BRIGHTNESS BUTTON
BUTTON_EVENT[dvTP, 9]           // SATURATION BUTTON
{
    PUSH:
    {
        OFF[dvTP, 1]
        OFF[dvTP, 4]
        OFF[dvTP, 5]
        OFF[dvTP, 6]
        OFF[dvTP, 9]
        ON[dvTP, BUTTON.INPUT.CHANNEL]
        SWITCH(BUTTON.INPUT.CHANNEL)
        {
            CASE 1:
            {
                IF(!nDEVICE_SCALE)
                {
                    SEND_COMMAND dvTP, "'@TXT',10, ITOA(slHUE),'%'"
                    SEND_LEVEL dvTP,1,slHUE*255/100
                }
                ELSE
                {
                    STACK_VAR SLONG slVAL
                    
                    SEND_COMMAND dvTP, "'@TXT',10,ITOA(slHUE)"
                    slVAL = slHUE
                    slVAL = Scale_Range(slVAL, -180, 180, 0, 100)
                    SEND_LEVEL dvTP, 1, slVAL*255/100
                }
                nENABLE_LEVEL=0
                CANCEL_WAIT 'ENABLE LEVELS'
                WAIT 3 'ENABLE LEVELS' { nENABLE_LEVEL = 1 } // REMOVES UNDESIRABLE ECHO FEEDBACK
            }
            CASE 4:
            {
                IF (!nDEVICE_SCALE)
                {
                    SEND_COMMAND dvTP, "'@TXT',10,ITOA(slSHARPNESS),'%'"
                    SEND_LEVEL dvTP,1,slSHARPNESS*255/100
                }
                ELSE
                {
                    STACK_VAR SLONG slVAL
                    
                    SEND_COMMAND dvTP, "'@TXT',10,ITOA(slSHARPNESS)"
                    slVAL = slSHARPNESS
                    slVAL = Scale_Range(slVAL, -8, 7, 0, 100)
                    SEND_LEVEL dvTP,1,slVAL*255/100
                }
                nENABLE_LEVEL=0
                CANCEL_WAIT 'ENABLE LEVELS'
                WAIT 3 'ENABLE LEVELS' { nENABLE_LEVEL = 1 } // REMOVES UNDESIRABLE ECHO FEEDBACK
            }
            CASE 5:
            {
                IF (!nDEVICE_SCALE)
                {
                    SEND_COMMAND dvTP, "'@TXT',10,ITOA(slCONTRAST),'%'"
                    SEND_LEVEL dvTP,1,slCONTRAST*255/100
                }
                ELSE
                {
                    STACK_VAR SLONG slVAL
                    
                    SEND_COMMAND dvTP, "'@TXT',10,ITOA(slCONTRAST)"
                    slVAL = slCONTRAST
                    slVAL = Scale_Range(slVAL, 0, 199, 0, 100)
                    SEND_LEVEL dvTP,1,slVAL*255/100
                }
                nENABLE_LEVEL=0
                CANCEL_WAIT 'ENABLE LEVELS'
                WAIT 3 'ENABLE LEVELS' { nENABLE_LEVEL = 1 } // REMOVES UNDESIRABLE ECHO FEEDBACK
            }
            CASE 6:
            {
                IF (!nDEVICE_SCALE)
                {
                    SEND_COMMAND dvTP, "'@TXT',10,ITOA(slBRIGHTNESS),'%'"
                    SEND_LEVEL dvTP,1,slBRIGHTNESS*255/100
                }
                ELSE 
                {
                    STACK_VAR SLONG slVAL
                    
                    SEND_COMMAND dvTP, "'@TXT',10,ITOA(slBRIGHTNESS)"
                    slVAL = slBRIGHTNESS
                    slVAL = Scale_Range(slVAL, -500, 500, 0, 100)
                    SEND_LEVEL dvTP,1,slVAL*255/100
                }
                nENABLE_LEVEL=0
                CANCEL_WAIT 'ENABLE LEVELS'
                WAIT 3 'ENABLE LEVELS' { nENABLE_LEVEL = 1 } // REMOVES UNDESIRABLE ECHO FEEDBACK
            }
            CASE 9:
            {
                IF(!nDEVICE_SCALE)
                {
                    SEND_COMMAND dvTP, "'@TXT',10, ITOA(slSATURATION),'%'"
                    SEND_LEVEL dvTP,1,slSATURATION*255/100
                }
                ELSE
                {
                    STACK_VAR SLONG slVAL
                    
                    SEND_COMMAND dvTP, "'@TXT',10,ITOA(slSATURATION)"
                    slVAL = slSATURATION
                    slVAL = Scale_Range(slVAL, 0, 199, 0, 100)
                    SEND_LEVEL dvTP, 1, slVAL*255/100
                }
                nENABLE_LEVEL=0
                CANCEL_WAIT 'ENABLE LEVELS'
                WAIT 3 'ENABLE LEVELS' { nENABLE_LEVEL = 1 } // REMOVES UNDESIRABLE ECHO FEEDBACK
            }
        }
    }
}
BUTTON_EVENT[dvTP, 10]          // OVER_SCAN BUTTON
{
    PUSH:
    {
        IF ([dvTP, 10]) { SEND_COMMAND vdvDEV, "'OVER_SCAN=',ITOA(nCUR_INPUT),':OFF'" }
        ELSE { SEND_COMMAND vdvDEV, "'OVER_SCAN=',ITOA(nCUR_INPUT),':ON'" }
    }
}
BUTTON_EVENT[dvTP, 11]          // current input 1 button
BUTTON_EVENT[dvTP, 12]          // current input 2 button
BUTTON_EVENT[dvTP, 13]          // current input 3 button
BUTTON_EVENT[dvTP, 14]          // current input 4 button
{
    PUSH:
    {
        STACK_VAR INTEGER N
        
        FOR (N = 11; N <= 14; N++) { OFF[dvTP, N] }
        ON[dvTP, BUTTON.INPUT.CHANNEL]
        nCUR_INPUT = BUTTON.INPUT.CHANNEL - 10
        SEND_COMMAND vdvDEV, "'INPUT_TYPE?',ITOA(nCUR_INPUT)"
        SEND_COMMAND vdvDEV, "'FREEZE?',ITOA(nCUR_INPUT)"
        SEND_COMMAND vdvDEV, "'BRIGHTNESS?',ITOA(nCUR_INPUT)"
        SEND_COMMAND vdvDEV, "'CONTRAST?',ITOA(nCUR_INPUT)"
        SEND_COMMAND vdvDEV, "'SHARPNESS?',ITOA(nCUR_INPUT)"
        SEND_COMMAND vdvDEV, "'SATURATION?',ITOA(nCUR_INPUT)"
        SEND_COMMAND vdvDEV, "'HUE?',ITOA(nCUR_INPUT)"
    }
}
BUTTON_EVENT[dvTP, 15]          // QUAD BUTTON
BUTTON_EVENT[dvTP, 16]          // INPUT 1 BUTTON
BUTTON_EVENT[dvTP, 17]          // INPUT 2 BUTTON
BUTTON_EVENT[dvTP, 18]          // INPUT 3 BUTTON
BUTTON_EVENT[dvTP, 19]          // INPUT 4 BUTTON
{
    PUSH:
    {
        PULSE[dvTP, BUTTON.INPUT.CHANNEL]
        SEND_COMMAND vdvDEV, "'FULL_SCREEN=',ITOA(BUTTON.INPUT.CHANNEL - 15)"
    }
}
BUTTON_EVENT[dvTP, 20]          // BANK A INPUTS BUTTON
BUTTON_EVENT[dvTP, 21]          // BANK B INPUTS BUTTON
{
    PUSH:
    {
        PULSE[dvTP, BUTTON.INPUT.CHANNEL]
        IF (BUTTON.INPUT.CHANNEL == 20 ) { SEND_COMMAND vdvDEV, "'BANK=A'" }
        ELSE IF (BUTTON.INPUT.CHANNEL == 21) { SEND_COMMAND vdvDEV, "'BANK=B'" }
    }
}
BUTTON_EVENT[dvTP, 23]          // FREEZE BUTTON
{
    PUSH:
    {
        IF ([dvTP, 23]) { SEND_COMMAND vdvDEV, "'FREEZE=0:',ITOA(nCUR_INPUT)" }
        ELSE { SEND_COMMAND vdvDEV, "'FREEZE=1:',ITOA(nCUR_INPUT)" }
    }
}
BUTTON_EVENT[dvTP, 24]          // FRONT PANEL LOCK TOGGLE BUTTON
{
    PUSH:
    {
        IF ([dvTP, 24]) { SEND_COMMAND vdvDEV, "'LOCK=0'" }
        ELSE { SEND_COMMAND vdvDEV, "'LOCK=1'" }
        PULSE[dvTP, 24]
    }
}
BUTTON_EVENT[dvTP, 25]          // LCD BACKLIGHT TOGGLE BUTTON
{
    PUSH:
    {
        PULSE[dvTP, 25]
        SEND_COMMAND vdvDEV, "'DIMMER'"
    }
}
BUTTON_EVENT[dvTP, 26]          // FRAME LOCK TOGGLE BUTTON
{
    PUSH:
    {
        IF ([dvTP, 26]) { SEND_COMMAND vdvDEV, "'FRAME_LOCK=0'" }
        ELSE { SEND_COMMAND vdvDEV, "'FRAME_LOCK=1'" }
        PULSE[dvTP, 26]
    }
}
BUTTON_EVENT[dvTP, 27]          // LEVEL EXIT BUTTON
{
    PUSH:
    {
        OFF[dvTP, 1]            // HUE BUTTON
        OFF[dvTP, 4]            // SHARPNESS BUTTON
        OFF[dvTP, 5]            // CONTRAST BUTTON
        OFF[dvTP, 6]            // BRIGHTNESS BUTTON
        OFF[dvTP, 7]            // PRIORITY BUTTON
        OFF[dvTP, 9]            // SATURATION BUTTON
    }
}

BUTTON_EVENT[dvTP, 30]          // COMPOSITE-A BUTTON
BUTTON_EVENT[dvTP, 31]          // COMPOSITE-B BUTTON
BUTTON_EVENT[dvTP, 32]          // S-VIDEO BUTTON
{
    PUSH:
    {
        PULSE[dvTP, BUTTON.INPUT.CHANNEL]
        SWITCH(BUTTON.INPUT.CHANNEL)
        {
            CASE 30: { SEND_COMMAND vdvDEV, "'INPUT_TYPE=',ITOA(nCUR_INPUT),':COMPOSITE-A'" }
            CASE 31: { SEND_COMMAND vdvDEV, "'INPUT_TYPE=',ITOA(nCUR_INPUT),':COMPOSITE-B'" }
            CASE 32: { SEND_COMMAND vdvDEV, "'INPUT_TYPE=',ITOA(nCUR_INPUT),':S-VIDEO'" }
        }
    }
}
BUTTON_EVENT[dvTP, 34]          // OPERATING STANDARD NNP BUTTON
BUTTON_EVENT[dvTP, 35]          // OPERATING STANDARD NNI BUTTON
BUTTON_EVENT[dvTP, 36]          // OPERATING STANDARD NWP BUTTON
BUTTON_EVENT[dvTP, 37]          // OPERATING STANDARD PNI BUTTON
{
    PUSH:
    {
        PULSE[dvTP, BUTTON.INPUT.CHANNEL]
        SEND_COMMAND vdvDEV, "'OPERATING_STANDARD=',ITOA(BUTTON.INPUT.CHANNEL - 33)"
    }
}

BUTTON_EVENT[dvTP, 80]          // GLOBAL SAVE BUTTON
{
    PUSH:
    {
        PULSE[dvTP, 80]
        SEND_COMMAND vdvDEV, "'GLOBAL_SAVE'"
    }
}
(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM

[dvTP, 10] = (nOVERSCAN)        // OVER_SCAN

[dvTP, 15] = (nFULLSCREEN == 0) // QUADRANT VIEW ACTIVE
[dvTP, 16] = (nFULLSCREEN == 1) // INPUT 1 FULL SCREEN
[dvTP, 17] = (nFULLSCREEN == 2) // INPUT 2 FULL SCREEN
[dvTP, 18] = (nFULLSCREEN == 3) // INPUT 3 FULL SCREEN
[dvTP, 19] = (nFULLSCREEN == 4) // INPUT 4 FULL SCREEN

[dvTP, 20] = (nBANK == 1)       // BANK A INPUT CHANNELS
[dvTP, 21] = (nBANK == 2)       // BANK B INPUT CHANNELS

[dvTP, 23] = (nFREEZE)          // FREEZE STATE
[dvTP, 24] = (nLOCK)            // FRONT PANEL LOCKOUT
[dvTP, 25] = (nDIMMER)          // FRONT PANEL LCD BACKLIGHT
[dvTP, 26] = (nFRAMELOCK)       // FRAME LOCK

[dvTP, 30] = (nCUR_TYPE == 1)   // COMPOSITE-A INPUT TYPE
[dvTP, 31] = (nCUR_TYPE == 2)   // COMPOSITE-B INPUT TYPE
[dvTP, 32] = (nCUR_TYPE == 3)   // S-VIDEO INPUT TYPE

[dvTP, 34] = (nSTANDARD == 1)   // OPERATING STANDARD NNP
[dvTP, 35] = (nSTANDARD == 2)   // OPERATING STANDARD NNI
[dvTP, 36] = (nSTANDARD == 3)   // OPERATING STANDARD NWP
[dvTP, 37] = (nSTANDARD == 4)   // OPERATING STANDARD PNI
(***********************************************************)
(*                     END OF PROGRAM                      *)
(*        DO NOT PUT ANY CODE BELOW THIS COMMENT           *)
(***********************************************************)